--EuphedInst.ex     An installation program to install all components for the Euphed text editor


include file.e
include graphics.e

--The file list contains entries for each file to be installed. There must be a pair of entries for each file.
--The first refers to the Euphoria directory to contain the file and the second the filename itself.

constant  file_list = {
	"BIN","EUPHED.EXE",
	"BIN","EUPHED.HLP",
	"DOC","HELP.TXT"}

object environment		--The path to the Euphoria directory
sequence EuphDir 		--Used for the destination paths
sequence directory		--destination directory
integer f			--file handles
integer rename_letter	--letter to be prepended to original file
sequence rename_dir		--full path and name of renamed file
sequence source_dir		--path of source directory
object reply

procedure fail(integer failtype)
	if failtype = 1 then
		puts(1,"The euphoria system does not appear to have been installed.")
	elsif failtype = 2 then
		puts(1,"\nThe directory ")
		puts(1,EuphDir)
		puts(1," cannot be found.\n")
		puts(1,"Please ensure that Euphoria was correctly installed and try again.\n")
	elsif failtype=3 then
		puts(1,"Unable to find the source file ")
		puts(1,EuphDir)
		puts(1,".\nTry running WinInstall again from the directory containing the source files.\n")
	end if
	abort(1)
end procedure

procedure rename(sequence dir,sequence oldfile)
sequence oldpath,command
	rename_letter = 'A'
	oldpath=environment & "\\" & dir & "\\" & oldfile
	while rename_letter <= 'Z' do
		rename_dir = environment & "\\" & dir & "\\" & rename_letter & oldfile
		f=open(rename_dir,"rb")
		if f= -1 then 
			--no file of that name
			command="rename " & oldpath & " "  & rename_letter & oldfile
			system(command,2)
		    	puts(1,EuphDir & " has been renamed as\n" & rename_dir & "\n")
			exit
		else close(f)
		rename_letter+=1
		end if
	end while
	if rename_letter > 'Z' then
		puts(1,"Unable to rename " & EuphDir & "\nPlease delete the earliest of the renamed files and try again. Press a key\n\n")
		reply=gets(0)
		abort(1)
	end if
end procedure

--Check that Euphoria has been installed
environment=getenv("EUDIR")
if atom(environment)=1 then
	fail(1)
end if

--Now check that each of the destination directories have been set up


for j=1 to length(file_list) by 2 do
	directory = file_list[j]
	EuphDir=environment & "\\" & directory
	reply=dir(EuphDir)
	if sequence(reply)=0 then fail(2) end if
end for

--Get the source directory

sequence temp
temp = command_line()
integer ptr

for j=length(temp[2]) to 1 by -1 do
	if compare(temp[2][j],'\\')=0 then
		 ptr=j-1
		exit
	end if
end for

if ptr=0 then fail(4) end if
source_dir="chdir " & temp[2][1..ptr]

system (source_dir,2)
	
--Now check which program to use for moving the files

object move_command
move_command = "C:\\DOS\\MOVE.EXE " -- DOS 6
if atom(dir(move_command)) then
    move_command = "C:\\WINDOWS\\COMMAND\\MOVE.EXE " -- DOS 7
    if atom(dir(move_command)) then
	move_command = -1 -- assume no move command
    end if
end if

procedure move()

--Try to find the source files
	for j=1 to length(file_list) by 2 do
		EuphDir= file_list[j+1]
		f=open(EuphDir,"rb")
		if f = -1 then fail(3) end if
		close(f)
	end for

--All found, so check whether they have already been installed and if so rename them
	for j=1 to length(file_list) by 2 do
		EuphDir= environment & "\\" & file_list[j] & "\\" & file_list[j+1]
		f=open(EuphDir,"rb")
		if f!= -1 then 
			close(f)
			--file has already been installed so rename it
			rename( file_list[j], file_list[j+1])
		end if
		system(move_command &"  " & file_list[j+1] & "  " & EuphDir,2)
		puts(1,"File " & file_list[j+1] & " has been moved to " & EuphDir & "\n\n")
	end for
end procedure

move()
puts(1,"\nInstallation completed\n")

